/*
 * Copyright (c) 2016, Thibaud Ehret <ehret.thibaud@gmail.com>
 * All rights reserved.
 *
 * This program is free software: you can use, modify and/or
 * redistribute it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either
 * version 3 of the License, or (at your option) any later
 * version. You should have received a copy of this license along
 * this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NFA_H_INCLUDED
#define NFA_H_INCLUDED

#include <vector>
#include "LibVideoT.hpp"

int computeConnectedComponent(Video<bool> binary, std::vector<std::vector<unsigned> >& coords, std::vector<unsigned>& size);

float estimateDistribution(Video<float> diff, int k1, int k2, long double& proba1, long double& proba2);

long double computeNFAs(Video<float> original, Video<float> diff, int k1, int k2, Video<float>& visual_nfa, int& type, long double nfa_threshold, int tests = 1);

#endif // NFA_H_INCLUDED
