% loads an image and allows the user to select a pixel
% for the selected pixel, it displays the locations 
% of the most similar patches in a database image and other stuffs !

%clear all

setenv('LD_LIBRARY_PATH',[getenv('PATH')]);

% parameters
prms.px = 16;
prms.np = 64;
sigma = '0';

computeTrue = true;

% binary that computes patch distances 
pgbin = '../build/bin/info';

% path to data 
input_path = '../build/bin/';

clear seqnames first last

vinput = [input_path 'input_0.jpg'];
data = [input_path 'input_1.jpg'];

command = [pgbin ...
           ' -i ' vinput ...
           ' -data ' data ...
           ' -px ' num2str(prms.px) ...
           ' -np ' num2str(prms.np)];

vinput = imread(vinput);
if(size(vinput,3) == 1)
    vinput = repmat(vinput, [1,1,3]);
end
data = imread(data);
if(size(data,3) == 1)
    data = repmat(data, [1,1,3]);
end

input0 = vinput;
input1 = data;

% show sequence
goon = 1;
fig_h = figure(1);
imagesc(vinput);
axis equal, axis off

position_group1 = data;
position_group2 = data;

key = '';
%set(fig_h,'KeyPressFcn', @(~, evt) assignin('base', 'key', evt.Key)); 


while (goon)
    key = input('', 's');
	switch (key)
        case 's'
            if (key == 's')
                figure(1)
                [pax,pay] = ginput(1);
                pax = round(pax);
                pay = round(pay);
            end
            % compute patch group
            cmd = [command ...
                  ' -PAx ' num2str(pax - 1) ... 
                  ' -PAy ' num2str(pay - 1) ... 
                  ' -out /tmp/patches/'];

            unix('rm -r /tmp/patches');
            unix('mkdir /tmp/patches');
            unix(cmd);

            % separate command outputs into matlab readable files
            unix('cat /tmp/patches/group1.out | grep COORD | sed -s ''s/\[COORD\]//'' > /tmp/patches/group1.coords.out');
            unix('cat /tmp/patches/group1.out | grep DISTA | sed -s ''s/\[DISTA\]//'' > /tmp/patches/group1.distas.out');
            unix('cat /tmp/patches/group2.out | grep COORD | sed -s ''s/\[COORD\]//'' > /tmp/patches/group2.coords.out');
            unix('cat /tmp/patches/group2.out | grep DISTA | sed -s ''s/\[DISTA\]//'' > /tmp/patches/group2.distas.out');
            
            position_group1 = data;
            position_group2 = data;
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

            patches_group1.coords = load('/tmp/patches/group1.coords.out') + 1;
            patches_group1.distas = load('/tmp/patches/group1.distas.out');

            indr = sub2ind(size(vinput),patches_group1.coords(:,2), ...
                                      patches_group1.coords(:,1), ...
                                      ones(size(patches_group1.coords,1),1), ...
                                      patches_group1.coords(:,3));

            indg = sub2ind(size(vinput),patches_group1.coords(:,2), ...
                                      patches_group1.coords(:,1), ...
                                      2*ones(size(patches_group1.coords,1),1), ...
                                      patches_group1.coords(:,3));

            indb = sub2ind(size(vinput),patches_group1.coords(:,2), ...
                                      patches_group1.coords(:,1), ...
                                      3*ones(size(patches_group1.coords,1),1), ...
                                      patches_group1.coords(:,3));

            % show search region for all frames
            position_group1(indr(1: end)) = 0; position_group1(indg(1: end))   =   0; position_group1(indb(1: end))   =   255;
            
            figure(4)
            imagesc(position_group1)
            axis equal, axis off
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

            patches_group2.coords = load('/tmp/patches/group2.coords.out') + 1;
            patches_group2.distas = load('/tmp/patches/group2.distas.out');

            indr = sub2ind(size(vinput),patches_group2.coords(:,2), ...
                                      patches_group2.coords(:,1), ...
                                      ones(size(patches_group2.coords,1),1), ...
                                      patches_group2.coords(:,3));

            indg = sub2ind(size(vinput),patches_group2.coords(:,2), ...
                                      patches_group2.coords(:,1), ...
                                      2*ones(size(patches_group2.coords,1),1), ...
                                      patches_group2.coords(:,3));

            indb = sub2ind(size(vinput),patches_group2.coords(:,2), ...
                                      patches_group2.coords(:,1), ...
                                      3*ones(size(patches_group2.coords,1),1), ...
                                      patches_group2.coords(:,3));

            % show search region for all frames
            position_group2(indr(1: end)) = 255; position_group2(indg(1: end))   =   0; position_group2(indb(1: end))   =   0;
            
            figure(5)
            imagesc(position_group2)
            axis equal, axis off

            figure(6)
            plot(1:prms.np, patches_group1.distas, 1:prms.np, patches_group2.distas);
        case 'q'
            goon = 0;
        otherwise
    end
    
    key = '';
% 
% 	figure(1)
% 	current_axes = [get(gca,'XLim') get(gca,'YLim')];
% 	imagesc(vinput);
% 	axis equal, axis off, axis(current_axes)
%     hold on
% 	%plot(pax, pay, '*r')
% 	hold off
% 
% 	vinput = input0;
%     data = input1;
end

close all;


